{%- import "src/_rda_template.j2" as rda_dmp_cs with context -%}
{%- import "src/_utils.j2" as utils with context -%}
{%- import "src/_tree_utils.j2" as tree with context -%}
{%- import "src/_distribution.j2" as distribution with context -%}
{%- import "src/_elsi.j2" as elsi with context -%}



{#- ------------------------------------------------------------  -#}
{#- globals to THIS file, which we call locals... -#}
{#- ------------------------------------------------------------  -#}
{#- variables global to this file, not meant to be used by the caller  -#}

{%- set local_ns = namespace(description="types") -%}

{%- set local_ns.var_stack = [] -%}
{#- keeping track of item path for dataset -#}
{%- set local_ns.dataset_id_item_path = none -%}

{#- collects all types for a given dataset name -#}
{%- set local_ns.type_list = []  -%}
{%- set local_ns.dataset_id_types = ["handle", "doi", "ark", "url", "other"] -%}

{#- ------------------------------------------------------------  -#}
{#- end of globals  -#}
{#- ------------------------------------------------------------  -#}

{#- ------------------------------------------------------------  -#}
{#- specific dataset utilities -#}
{#- ------------------------------------------------------------  -#}


{%- macro checkIfNameListOK(globals, dmp_being_built) -%}
  {#- need to check if all datasets have names: they might not have...   -#}
  {#- before we clone dataset according to the number of types  -#}
  {#- we must have   -#}
  {#- globals.global_ns.dataset_map_name_titles|length == globals.global_ns.dataset_name_list|length - 1 -#}
  {#- since we create one dataset before implementing the cloning process -#}

  {%- set name_list = globals.global_ns.dataset_vars.name_list -%}
  {%- set map_name_titles = globals.global_ns.dataset_vars.map_name_titles -%}
  
  {%- set answer = false -%}
  {#-{{ "\nname_list " ~ name_list }}-#}
  {#-{{ "\nmap_name_titles " ~ map_name_titles }}-#}

  {#- it must be the case that  name_list|length == map_name_titles|length + 1 -#}
  {#- because checkNameList is only called from the cloning macro -#}
  {#- at the point where the corresponding map_name_titles -#}
  {#- has not been created yet -#}
  {%- if name_list|length != map_name_titles|length + 1 -%}
    {{ utils.warningMessage(false, "in formDatasetTitlesAndClone, a dataset created has no name, it will be dismissed") }}

    {#- if name_list|length != map_name_titles|length + 1 -#}
    {#- then it can only mean that the last dataset had no name -#}
    {#- as the annotation DatasetName was not processed (ie not seen, as no reply) -#}
    {#- -#}
    {#- we do not accept such a dataset, we'll remove it from dmp_being_built -#}
    {%- do dmp_being_built.dataset.pop() -%}
  {%- else -%}
    {%- set answer = true -%}
  {%- endif -%}

  {%- do local_ns.var_stack.append(answer) -%}
{%- endmacro -%}



{%- macro checkDatasetDatasetIdExists(dmp_being_built) -%}
  {#- need to check if all datasets so far have dataset_id.type and dataset_id.identifier -#}
  {#- properties -#}
  {#- before we clone dataset according to the number of types  -#}
  {#- -#}
  {#- since this macro is called before the cloning, we need only check -#}
  {#- dmp_being_built.dataset[dmp_being_built.dataset|length - 1]  -#}

  {%- if dmp_being_built.dataset|length == 0 -%}
    {{ utils.warningMessage(false, "in checkDatasetDatasetIdExists, something is very wrong:   dmp_being_built.dataset|length == 0") }}
  {%- else -%}
    {#- implement constraints as in https://github.com/RDA-DMP-Common/RDA-DMP-Common-Standard#dataset_id_table  -#}
    {%- if not dmp_being_built.dataset[dmp_being_built.dataset|length - 1].dataset_id.type  -%}
      {%- do dmp_being_built.dataset[dmp_being_built.dataset|length - 1].dataset_id.update({ "type" : "other" }) -%}
    {%- endif -%}
    {%- if not dmp_being_built.dataset[dmp_being_built.dataset|length - 1].dataset_id.identifier  -%}
      {%- do dmp_being_built.dataset[dmp_being_built.dataset|length - 1].dataset_id.update({ "identifier" : "no identifier given" }) -%}
    {%- endif -%}
  {%- endif -%}

{%- endmacro -%}



{#- ------------------------------------------------------------  -#}
{#- macros to execute once all the dataset records have been read -#}
{#- in question Les produits de la recherche   -#}
{#- ------------------------------------------------------------  -#}



{%- macro formDatasetTitlesAndClone(globals, dmp_being_built) -%}
  {#- from dmp_being_built.dataset[dmp_being_built.dataset|length - 1].title and each type in  -#}
  {#- local_ns.type_list, form the dataset title as name-type  -#}
  {#- as RDA DMP CS accepts only one type per dataset   -#}

  {#- invariant   -#}
  {#- need to check if all datasets have names: they might not have...   -#}
  {#- {{ "formDatasetTitlesAndClone " ~ global_ns.dataset_name_list }} -#}
  {{ checkIfNameListOK(globals, dmp_being_built) }} 

  {%- set answer = local_ns.var_stack.pop() -%}
  {%- if answer -%}
    {#- before cloning etc, we ensure that cardinalities for the property  -#}
    {#- dmp_being_built.dataset.dataset_id is 1  -#}
    {#- the same applies to dmp_being_built.dataset.title, see below  -#}
    {{ checkDatasetDatasetIdExists(dmp_being_built) }} 
    
    {%- set name_list = globals.global_ns.dataset_vars.name_list -%}
    {%- set map_name_titles = globals.global_ns.dataset_vars.map_name_titles -%}
    {%- set bioimagery_titles = globals.global_ns.dataset_vars.bioimagery_titles  -%}
    {%- set cytometry_titles = globals.global_ns.dataset_vars.cytometry_titles  -%}
    {%- set genomics_titles = globals.global_ns.dataset_vars.genomics_titles  -%}
    {%- set proteomics_titles = globals.global_ns.dataset_vars.proteomics_titles  -%}
    {%- set metabolomics_titles = globals.global_ns.dataset_vars.metabolomics_titles  -%}
    {%- set other_data_titles = globals.global_ns.dataset_vars.other_data_titles  -%}
    
    {#- {{ "in formDatasetTitlesAndClone " ~ local_ns.type_list }}-#}
    {%- set local_ns.title_list = [] -%} 
    
    {#- get the name we updated in processDatasetName() -#}
    {#- or checkNameList()  -#}
    {%- set name = name_list|last -%}

    {% if local_ns.type_list|length == 0  -%}
      {#- types might not have been filled in  -#}
      {#- so we simply update local_ns.title_list with name  -#}
      {%- do local_ns.title_list.append(name)  -%}
    {%- else   -%}
      {%- for type in local_ns.type_list  -%}
        {{ utils.cleanVarName(type) }}
        {%- set type_clean = utils.global_ns.var_stack.pop() -%}
        {%- set title = name ~ "-" ~ type_clean -%}
        {%- do local_ns.title_list.append(title)  -%}
        {%- if type_clean == "Image" -%}
          {%- do bioimagery_titles.append(title) -%}
        {%- elif type_clean == "Jeux_de_donnees_cytometrie" -%}
          {%- do cytometry_titles.append(title)  -%}
        {%- elif type_clean == "Jeux_de_donnees_genomiques" -%}
          {%- do genomics_titles.append(title)  -%}
        {%- elif type_clean == "Jeux_de_donnees_proteomiques" -%}
          {%- do proteomics_titles.append(title)  -%}
        {%- elif type_clean == "Jeux_de_donnees_metabolomiques" -%}
          {%- do metabolomics_titles.append(title)  -%}
        {%- elif type_clean == "Jeux_de_donnees_autres" -%}
          {%- do other_data_titles.append(title)  -%}
        {%- endif -%}
      {%- endfor -%}
    {%- endif -%}

    {#- update global_ns.dataset_map_name_titles  -#}
    {%- do map_name_titles.append(local_ns.title_list) -%}

    {%- set list_title_length = local_ns.title_list|length -%}
    {%- for i in range(list_title_length) -%}
      {#- recall that, when we start -#}
      {#- we have exactly one rda_dmp_cs.dataset created in dmp_being_built.dataset  -#}
      {#- for the name in global_ns.dataset_name_list|last -#}
      {#- this dataset is the last created -#}
      {#- dmp_being_built.dataset|last   -#}
      {%- if i == 0  -%}
        {%- do dmp_being_built.dataset[dmp_being_built.dataset|length - 1].update({ "title" : local_ns.title_list[i] })  -%}
        {#- local_ns.title_list has the same length as local_ns.type_list -#}
        {#- except when local_ns.type_list is empty then local_ns.title_list|length = 1  -#}
        {%- if local_ns.type_list  -%} 
          {%- do dmp_being_built.dataset[dmp_being_built.dataset|length - 1].update({ "type" : local_ns.type_list[i] })  -%}
        {%- endif -%}
        {%- set local_ns.first_dataset = dmp_being_built.dataset[dmp_being_built.dataset|length - 1] -%}
      {%- else -%}
        {{ utils.deepCopy(local_ns.first_dataset) }}
        {%- set dataset = utils.global_ns.var_stack.pop() -%}
        {%- do dataset.update({ "title" : local_ns.title_list[i] }) -%}
        {#- local_ns.title_list has the same length as local_ns.type_list -#}
        {#- except when local_ns.type_list is empty then local_ns.title_list|length = 1  -#}
        {%- if local_ns.type_list  -%} 
          {%- do dataset.update({ "type" : local_ns.type_list[i] })  -%}
        {%- endif -%}
        {%- do dmp_being_built.dataset.append(dataset) -%}
      {%- endif -%}
    {%- endfor -%}
  {%- endif -%}

{%- endmacro -%}



{%- macro doLastSetOfDatasetClones(globals, dmp_being_built) -%}
  {#- {{ "doLastSetOfClones " ~ global_ns.dataset_name_list }}  -#}
  {#- {{ "doLastSetOfClones " ~ global_ns.dataset_map_name_titles }}  -#}
  {{ formDatasetTitlesAndClone(globals, dmp_being_built) }}   
{%- endmacro -%}

{#- ----------------------------------------------------------------------- -#}
{#-  creation macros                                      -#}
{#- ----------------------------------------------------------------------- -#}

{%- macro createDataset(globals, dmp_being_built, uuid) -%}
  {#- we must distinguish if it is the first time we create a dataset object -#}
  {#- if not, we must clone the last dataset created and update the clones -#}
  {#- with their unique title according to their type -#}

  {%- if dmp_being_built.dataset|length > 0  -%} 
    {{ formDatasetTitlesAndClone(globals, dmp_being_built) }}  
  {%- endif -%}
  {#- clear types  -#}
  {%- set local_ns.type_list = []  -%}

  {#- do a deep copy of rda_dmp_cs.dataset -#}
  {#- we MUST do this, as in jinja2 all vars are accessed by reference... -#}
  {{ utils.deepCopy(rda_dmp_cs.dataset) }}
  {#- we retrieve the copy of rda_dmp_cs.dataset -#}
  {%- set new_dataset = utils.global_ns.var_stack.pop() -%}

  {#- note that it makes sense to create the distribution attribute now -#}
  {#- as physical sites info is collected at the very beginning of the questionnaire -#}
  {{ distribution.createDatasetDistribution(globals, new_dataset) }}

  {%- set datasets = dmp_being_built.dataset -%}
  {#- and append one dataset to the already existing list of datasets -#} 
  {%- do datasets.append(new_dataset) -%}
{%- endmacro -%}

{%- macro createDatasetDatasetId(globals, dmp_being_built, uuid) -%}
  {#- in DSW we allow for more than one dataset_id block -#}
  {#- but RDA DMP CS does not, so we pick the first encountered -#}
  {#- -#}
  {#- we test this by checking the length of -#}
  {#- dmp_being_built.dataset[dmp_being_built.dataset|length - 1].dataset_id  -#}
  {#- if zero, it means dans the dict dataset_id = {}, ie, no keys -#}

  {%- if dmp_being_built.dataset[dmp_being_built.dataset|length - 1].dataset_id|length == 0 -%}
    {#- we retrieve the copy of rda_dmp_cs.dataset_id -#}
    {{ utils.deepCopy(rda_dmp_cs.dataset_id) }}
    {%- set obj = utils.global_ns.var_stack.pop() -%}
    {%- do dmp_being_built.dataset[dmp_being_built.dataset|length - 1].update({ "dataset_id" : obj }) -%} 

    {#- we need to control the update  of dataset.dataset_id -#}
    {#- with dataset.dataset_id.type  and dataset.dataset_id.identifier -#}
    {#- -#}
    {#- because dataset.dataset_id is an item from an ItemList question  -#}
    {#- there may be several occurences of it in the DSW KM -#}
    {#- moreover, there may be empty answers in the block dataset.dataset_id  -#}
    {#- -#}
    {#- in the case say, not all items, here a  dataset_id block, -#}
    {#- have a corresponding object in dmp_being_built, -#}
    {#- we must guarantee that the attributes updated,  -#}
    {#- encountered thanks to their corresponding annotations, -#}
    {#- apply to the item dataset_id of interest  -#}
    {#- (here the first and only one in dmp_being_built) -#}
    {#- -#}
    {#- in other words, -#}
    {#- processDatasetIdType  -#}
    {#- may NOT apply to the same item DatasetId as processDatasetid_item_path   -#}
    {#- -#}
    {#- -#}
    {#- -#}
    {#- also see the macros processDatasetIdType -#}
    {#- and processDatasetIdIdentifier -#}
    {#- who themselves also handle the controls: -#}
    {#- -#}
    {#- controls are carried out by checking the respective paths of the answers -#}
    {#- and ensuring that their are prefixed by the path of the item dataset_id  -#}
    {#- -#}
    {#- we need to record the item path for this dataset_id -#}
    {#- for further comparison -#}
    {%- set dataset_id_item_uuid = uuid -%}
  {%- else -%} 
    {#- we do nothing: we have already created a datasetId for this dataset, -#}
    {#- we can't add another one -#}
    {#- and we already set "dataset_id_item_path -#}
  {%- endif -%} 
{%- endmacro -%}


{#- ----------------------------------------------------------------------- -#}
{#-  updating macros ()                                      -#}
{#- ----------------------------------------------------------------------- -#}

{#- ----------------------------------------------------------------------- -#}
{#-  dataset title                                       -#}
{#- ----------------------------------------------------------------------- -#}
{#- for title, type, id, -#}
{#- -#}
{#- we know that for each dataset item, we process the annotation -#}
{#- corresponding to the ListQuestion (item list) question -#}
{#- here, it is 'RDADataset' which triggers the creation of a dataset json object -#}
{#- -#}
{#- this implies that each time we process any of the item question of  -#}
{#- the item list (name, type, id), we are GUARANTEED that -#}
{#- the dataset being referred to  -#}
{#- is the LAST created, ie dmp_being_built.dataset[dmp_being_built.dataset|length - 1]  -#}
{#- -#}
{#- as for the name of this last created dataset is the last element in -#}
{#- globals.global_ns.dataset_name_list -#}


{%- macro processDatasetName(globals, dmp_being_built, reply) -%}
  {#- we use a temp (and global) var globals.global_ns.dataset_vars.name_list -#}
  {%- do globals.global_ns.dataset_vars.name_list.append(reply|trim) -%}
{%- endmacro -%}



{#- ----------------------------------------------------------------------- -#}
{#-  dataset type                                                           -#}
{#- ----------------------------------------------------------------------- -#}


{%- macro processDatasetType(dmp_being_built, reply) -%}
  {#- we use a temp var local_ns.type_list -#}
  {%- do local_ns.type_list.append(reply) -%}
{%- endmacro -%}


  
{#- ----------------------------------------------------------------------- -#}
{#-  dataset description                                                    -#}
{#- ----------------------------------------------------------------------- -#}

{%- macro processDatasetDescription(dmp_being_built, reply) -%}
  {#- we do know that at this stage the dataset in question has been created -#}
  {#- and is the last in the list -#}
  {%- do dmp_being_built.dataset[dmp_being_built.dataset|length - 1].update({ "description" : reply }) -%}
{%- endmacro -%}
  
{#- ----------------------------------------------------------------------- -#}
{#-  dataset identifier                                                    -#}
{#- ----------------------------------------------------------------------- -#}


{%- macro updateDatasetIdType(globals, dmp_being_built, reply) -%}
  {%- if reply|lower in local_ns.dataset_id_types -%}
    {%- do dmp_being_built.dataset[dmp_being_built.dataset|length - 1].dataset_id.update({ "type" : reply|lower }) -%}
  {%- else  -%}
    {%- do dmp_being_built.dataset[dmp_being_built.dataset|length - 1].dataset_id.update({ "type" : "other" }) -%}
  {%- endif -%}
{%- endmacro -%}


  
{%- macro processDatasetIdType(globals, dmp_being_built, reply, uuid) -%}
  {#- in DSW we accept that datasets might have more than one identifier -#}
  {#- this is not the case in RDA DMP CS -#}
  {#- we thus pick the first one, and ignore others -#}
  {#- -#}
  {#- to make sure we update the proper item in the item list -#}  
  {#- we use the corresponding controls, see createDatasetId()  -#}
  {#- -#}
  {#- we check that this answer's path is prefixed by dataset_id_item_uuid  -#}
  {#- to guarantee the answer applies to the required item   -#}
  {#- -#}
  {#- if dataset_id_item_path is null this means we have run out of contribu
torId -#}
  {#- for the current dataset (only one instance of datasetId -#}
  {#- per dataset -#}
  {#- so there is nothing to do: this reply is ignored  -#}

  {%- set id_item_uuid = local_ns.dataset_id_item_uuid  -%}
  {{ tree.isChildOf(globals, uuid, id_item_uuid) }}
  {%- set answer = tree.global_ns.var_stack.pop() -%}
  {%- if answer is true -%}
    {{ updateDatasetIdType(globals, dmp_being_built, reply) }}
  {%- endif -%}
{%- endmacro -%}

{%- macro updateDatasetIdIdentifier(dmp_being_built, reply) -%}
  {%- do dmp_being_built.dataset[dmp_being_built.dataset|length - 1].dataset_id.update({ "identifier" : reply}) -%}
{%- endmacro -%}


  
{%- macro processDatasetIdIdentifier(globals, dmp_being_built, reply, uuid) -%}
  {#- in DSW we accept that people might have more than on identifier -#}
  {#- this is not the case in RDA DMP CS -#}
  {#- we thus pick the first one, and ignore others -#}
  {#- -#}
  {#- to make sure we update the proper item in the item list -#}  
  {#- we use the corresponding controls, see createDatasetId()  -#}

  {%- set id_item_uuid = local_ns.dataset_id_item_uuid  -%}
  {{ tree.isChildOf(globals, uuid, id_item_uuid) }}
  {%- set answer = tree.global_ns.var_stack.pop() -%}
  {%- if answer is true -%}
    {{  updateDatasetIdIdentifier(dmp_being_built, reply) }}
  {%- endif -%}
{%- endmacro -%}
  

{#- ----------------------------------------------------------------------- -#}
{#-  dataset DataCollection                                                 -#}
{#- ----------------------------------------------------------------------- -#}


{%- macro setDataCollectionDatasetNames(globals, entity, reply)  -%}
  {#- need first to initialise -#}
  {%- do globals.global_ns.dataset_vars.update({ "data_collection_names" : [] }) -%}
  
  {{ utils.getDatasetNames(entity, globals.global_ns.dataset_vars.name_list, "DataCollection", reply) }}
  {%- set data_collection_names = utils.global_ns.var_stack.pop() -%}
  {%- do globals.global_ns.dataset_vars.update({ "data_collection_names" : data_collection_names }) -%}
{%- endmacro -%}





{#- ----------------------------------------------------------------------- -#}
{#-  other                                                  -#}
{#- ----------------------------------------------------------------------- -#}

{%- macro setBioimageryRoot(globals, uuid) -%}
  {%- do globals.global_ns.dataset_vars.update({ "bioimagery_root" : uuid }) -%}
{%- endmacro -%}

{%- macro setCytometryRoot(globals, uuid) -%}
  {%- do globals.global_ns.dataset_vars.update({ "cytometry_root" : uuid }) -%}
{%- endmacro -%}

{%- macro setProteomicsRoot(globals, uuid) -%}
  {%- do globals.global_ns.dataset_vars.update({ "proteomics_root" : uuid }) -%}
{%- endmacro -%}

{%- macro setGenomicsRoot(globals, uuid) -%}
  {%- do globals.global_ns.dataset_vars.update({ "genomics_root" : uuid }) -%}
{%- endmacro -%}

{%- macro setMetabolomicsRoot(globals, uuid) -%}
  {%- do globals.global_ns.dataset_vars.update({ "metabolomics_root" : uuid }) -%}
{%- endmacro -%}

{%- macro setOtherDataRoot(globals, uuid) -%}
  {%- do globals.global_ns.dataset_vars.update({ "other_data_root" : uuid }) -%}
{%- endmacro -%}
